#if BLUR_QUALITY == 6
const vec2 dofOffsets[60] = vec2[60](
                            vec2(  0.2165,  0.1250 ),
                            vec2(  0.0000,  0.2500 ),
                            vec2( -0.2165,  0.1250 ),
                            vec2( -0.2165, -0.1250 ),
                            vec2( -0.0000, -0.2500 ),
                            vec2(  0.2165, -0.1250 ),
                            vec2(  0.4330,  0.2500 ),
                            vec2(  0.0000,  0.5000 ),
                            vec2( -0.4330,  0.2500 ),
                            vec2( -0.4330, -0.2500 ),
                            vec2( -0.0000, -0.5000 ),
                            vec2(  0.4330, -0.2500 ),
                            vec2(  0.6495,  0.3750 ),
                            vec2(  0.0000,  0.7500 ),
                            vec2( -0.6495,  0.3750 ),
                            vec2( -0.6495, -0.3750 ),
                            vec2( -0.0000, -0.7500 ),
                            vec2(  0.6495, -0.3750 ),
                            vec2(  0.8660,  0.5000 ),
                            vec2(  0.0000,  1.0000 ),
                            vec2( -0.8660,  0.5000 ),
                            vec2( -0.8660, -0.5000 ),
                            vec2( -0.0000, -1.0000 ),
                            vec2(  0.8660, -0.5000 ),
                            vec2(  0.2163,  0.3754 ),
                            vec2( -0.2170,  0.3750 ),
                            vec2( -0.4333, -0.0004 ),
                            vec2( -0.2163, -0.3754 ),
                            vec2(  0.2170, -0.3750 ),
                            vec2(  0.4333,  0.0004 ),
                            vec2(  0.4328,  0.5004 ),
                            vec2( -0.2170,  0.6250 ),
                            vec2( -0.6498,  0.1246 ),
                            vec2( -0.4328, -0.5004 ),
                            vec2(  0.2170, -0.6250 ),
                            vec2(  0.6498, -0.1246 ),
                            vec2(  0.6493,  0.6254 ),
                            vec2( -0.2170,  0.8750 ),
                            vec2( -0.8663,  0.2496 ),
                            vec2( -0.6493, -0.6254 ),
                            vec2(  0.2170, -0.8750 ),
                            vec2(  0.8663, -0.2496 ),
                            vec2(  0.2160,  0.6259 ),
                            vec2( -0.4340,  0.5000 ),
                            vec2( -0.6500, -0.1259 ),
                            vec2( -0.2160, -0.6259 ),
                            vec2(  0.4340, -0.5000 ),
                            vec2(  0.6500,  0.1259 ),
                            vec2(  0.4325,  0.7509 ),
                            vec2( -0.4340,  0.7500 ),
                            vec2( -0.8665, -0.0009 ),
                            vec2( -0.4325, -0.7509 ),
                            vec2(  0.4340, -0.7500 ),
                            vec2(  0.8665,  0.0009 ),
                            vec2(  0.2158,  0.8763 ),
                            vec2( -0.6510,  0.6250 ),
                            vec2( -0.8668, -0.2513 ),
                            vec2( -0.2158, -0.8763 ),
                            vec2(  0.6510, -0.6250 ),
                            vec2(  0.8668,  0.2513 )
);								
#endif


#if BLUR_QUALITY == 5
const float PI_3 = 1.0471975512;
#define hexa(k) vec2(cos(PI_3 * k), sin(PI_3 * k))
const vec2 dofOffsets[6] =  vec2[6] (	
											hexa(0.), hexa(1.), hexa(2.), 
											hexa(3.), hexa(4.), hexa(5.) 
);
#endif

#if BLUR_QUALITY == 4
const vec2 dofOffsets[209]= vec2[209](vec2(0.8886414f , 0.07936136f),
                            vec2(0.8190064f , 0.1900164f),
                            vec2(0.8614115f , -0.06991258f),
                            vec2(0.7685533f , 0.03792081f),
                            vec2(0.9970094f , 0.02585129f),
                            vec2(0.9686818f , 0.1570935f),
                            vec2(0.9854341f , -0.09172997f),
                            vec2(0.9330608f , 0.3326486f),
                            vec2(0.8329557f , -0.2438523f),
                            vec2(0.664771f , -0.0837701f),
                            vec2(0.7429124f , -0.1530652f),
                            vec2(0.9506453f , -0.2174281f),
                            vec2(0.8192949f , 0.3485171f),
                            vec2(0.6851269f , 0.2711877f),
                            vec2(0.7665657f , 0.5014166f),
                            vec2(0.673241f , 0.3793408f),
                            vec2(0.6981376f , 0.1465924f),
                            vec2(0.6521665f , -0.2384985f),
                            vec2(0.5145761f , -0.05752508f),
                            vec2(0.5641244f , -0.169443f),
                            vec2(0.5916035f , 0.06004957f),
                            vec2(0.57079f , 0.234188f),
                            vec2(0.509311f , 0.1523665f),
                            vec2(0.4204576f , 0.05759521f),
                            vec2(0.8200846f , -0.3601041f),
                            vec2(0.6893264f , -0.3473432f),
                            vec2(0.4775535f , -0.3062558f),
                            vec2(0.438106f , -0.1796866f),
                            vec2(0.4056528f , -0.08251233f),
                            vec2(0.5771964f , 0.5502692f),
                            vec2(0.5094061f , 0.4025192f),
                            vec2(0.6908483f , 0.572951f),
                            vec2(0.5379036f , -0.4542191f),
                            vec2(0.8167359f , -0.4793735f),
                            vec2(0.6829269f , -0.4557574f),
                            vec2(0.5725697f , -0.3477072f),
                            vec2(0.5767449f , -0.5782524f),
                            vec2(0.3979413f , -0.4172934f),
                            vec2(0.4282598f , -0.5145645f),
                            vec2(0.938814f , -0.3239739f),
                            vec2(0.702452f , -0.5662871f),
                            vec2(0.2832307f , -0.1285671f),
                            vec2(0.3230537f , -0.2691054f),
                            vec2(0.2921676f , -0.3734582f),
                            vec2(0.2534037f , -0.4906001f),
                            vec2(0.4343273f , 0.5223463f),
                            vec2(0.3605334f , 0.3151571f),
                            vec2(0.3498518f , 0.451428f),
                            vec2(0.3230703f , 0.00287089f),
                            vec2(0.1049206f , -0.1476725f),
                            vec2(0.2063161f , -0.2608192f),
                            vec2(0.7266634f , 0.6725333f),
                            vec2(0.4027067f , -0.6185485f),
                            vec2(0.2655533f , -0.5912259f),
                            vec2(0.4947965f , 0.3025357f),
                            vec2(0.5760762f , 0.68844f),
                            vec2(0.4909205f , -0.6975324f),
                            vec2(0.8609334f , 0.4559f),
                            vec2(0.1836646f , 0.03724086f),
                            vec2(0.2878554f , 0.178938f),
                            vec2(0.3948484f , 0.1618928f),
                            vec2(0.3519658f , -0.7628763f),
                            vec2(0.6338583f , -0.673193f),
                            vec2(0.5511802f , -0.8283072f),
                            vec2(0.4090595f , -0.8717521f),
                            vec2(0.1482169f , -0.374728f),
                            vec2(0.1050598f , -0.2613987f),
                            vec2(0.4210334f , 0.6578422f),
                            vec2(0.2430464f , 0.4383665f),
                            vec2(0.3329675f , 0.5512741f),
                            vec2(0.2147711f , 0.3245511f),
                            vec2(0.1227196f , 0.2529026f),
                            vec2(-0.03937457f , 0.156439f),
                            vec2(0.05618772f , 0.06690486f),
                            vec2(0.06519571f , 0.3974038f),
                            vec2(0.1360903f , 0.1466078f),
                            vec2(-0.00170609f , 0.3089452f),
                            vec2(0.1357622f , -0.5088975f),
                            vec2(0.1604694f , -0.7453476f),
                            vec2(0.1245694f , -0.6337074f),
                            vec2(0.02542936f , -0.3728781f),
                            vec2(0.02222222f , -0.649554f),
                            vec2(0.09870815f , 0.5357338f),
                            vec2(0.2073958f , 0.5452989f),
                            vec2(0.216654f , -0.8935689f),
                            vec2(0.2422334f , 0.665805f),
                            vec2(0.0574713f , 0.6742729f),
                            vec2(0.2021346f , 0.8144029f),
                            vec2(0.3086587f , 0.7504997f),
                            vec2(0.02122174f , -0.7498575f),
                            vec2(-0.1551729f , 0.1809731f),
                            vec2(-0.1947583f , 0.06246066f),
                            vec2(-0.05754202f , -0.03901273f),
                            vec2(-0.1083095f , 0.2952235f),
                            vec2(-0.03259534f , -0.492394f),
                            vec2(-0.02488567f , -0.2081116f),
                            vec2(-0.1820729f , -0.1829884f),
                            vec2(-0.1674413f , -0.04529009f),
                            vec2(0.04342153f , -0.0368562f),
                            vec2(0.801399f , -0.5845526f),
                            vec2(0.3158276f , -0.9124843f),
                            vec2(-0.05945269f , 0.6727523f),
                            vec2(0.07701834f , 0.8579889f),
                            vec2(-0.05778154f , 0.5699022f),
                            vec2(0.1191713f , 0.7542591f),
                            vec2(-0.2578296f , 0.3630984f),
                            vec2(-0.1428598f , 0.4557526f),
                            vec2(-0.3304029f , 0.5055485f),
                            vec2(-0.3227198f , 0.1847367f),
                            vec2(-0.4183801f , 0.3412776f),
                            vec2(0.2538475f , 0.9317476f),
                            vec2(0.406249f , 0.8423664f),
                            vec2(0.4718862f , 0.7592828f),
                            vec2(0.168472f , -0.06605823f),
                            vec2(0.2632498f , -0.7084918f),
                            vec2(-0.2816192f , -0.1023492f),
                            vec2(-0.3161443f , 0.02489911f),
                            vec2(-0.4677814f , 0.08450397f),
                            vec2(-0.4156994f , 0.2408664f),
                            vec2(-0.237449f , 0.2605326f),
                            vec2(-0.0912179f , 0.06491816f),
                            vec2(0.01475127f , 0.7670643f),
                            vec2(0.1216858f , -0.9368939f),
                            vec2(0.07010741f , -0.841011f),
                            vec2(-0.1708607f , -0.4152923f),
                            vec2(-0.1345006f , -0.5842513f),
                            vec2(-0.09419055f , -0.3213732f),
                            vec2(-0.2149337f , 0.730642f),
                            vec2(-0.1102187f , 0.8425013f),
                            vec2(-0.1808572f , 0.6244397f),
                            vec2(-0.2414505f , -0.7063725f),
                            vec2(-0.2410318f , -0.537854f),
                            vec2(-0.1005938f , -0.7635075f),
                            vec2(0.1053517f , 0.9678772f),
                            vec2(-0.3340288f , 0.6926677f),
                            vec2(-0.2363931f , 0.8464488f),
                            vec2(-0.4057773f , 0.7786722f),
                            vec2(-0.5484858f , 0.1686208f),
                            vec2(-0.64842f , 0.02256887f),
                            vec2(-0.5544513f , -0.02348978f),
                            vec2(-0.492855f , -0.1083694f),
                            vec2(-0.4248196f , 0.4674786f),
                            vec2(-0.5873146f , 0.4072608f),
                            vec2(-0.6439911f , 0.3038489f),
                            vec2(-0.6419188f , 0.1293737f),
                            vec2(-0.005880734f , 0.4699725f),
                            vec2(-0.4239455f , 0.6250131f),
                            vec2(-0.1701273f , 0.9506347f),
                            vec2(7.665656E-05f , 0.9941212f),
                            vec2(-0.7070159f , 0.4426281f),
                            vec2(-0.7481344f , 0.3139496f),
                            vec2(-0.8330062f , 0.2472693f),
                            vec2(-0.7271438f , 0.2024286f),
                            vec2(-0.5179888f , 0.3149576f),
                            vec2(-0.8258062f , 0.3779382f),
                            vec2(-0.8063191f , 0.1262931f),
                            vec2(-0.2690676f , -0.4360798f),
                            vec2(-0.3714577f , -0.5887412f),
                            vec2(-0.3736085f , -0.4018324f),
                            vec2(-0.3228985f , -0.2063406f),
                            vec2(-0.2414576f , -0.2875458f),
                            vec2(-0.4720859f , -0.3823904f),
                            vec2(-0.4937642f , -0.2686005f),
                            vec2(-0.01500604f , -0.9587054f),
                            vec2(-0.08535925f , -0.8820614f),
                            vec2(-0.6436375f , -0.3157263f),
                            vec2(-0.5736347f , -0.4224878f),
                            vec2(-0.5026127f , -0.5516239f),
                            vec2(-0.8200902f , 0.5370023f),
                            vec2(-0.7196413f , 0.57133f),
                            vec2(-0.5849072f , 0.5917885f),
                            vec2(-0.1598758f , -0.9739854f),
                            vec2(-0.4230629f , -0.01858409f),
                            vec2(-0.9403627f , 0.2213769f),
                            vec2(-0.685889f , -0.2192711f),
                            vec2(-0.6693704f , -0.4884708f),
                            vec2(-0.7967147f , -0.3078234f),
                            vec2(-0.596441f , -0.1686891f),
                            vec2(-0.7366468f , -0.3939891f),
                            vec2(-0.7963406f , 0.02246814f),
                            vec2(-0.9177913f , 0.0929693f),
                            vec2(-0.9284672f , 0.3329005f),
                            vec2(-0.6497722f , 0.6851863f),
                            vec2(-0.496019f , 0.7013303f),
                            vec2(-0.3930301f , -0.6892192f),
                            vec2(-0.2122009f , -0.8777389f),
                            vec2(-0.3660335f , -0.801644f),
                            vec2(-0.386839f , -0.1191898f),
                            vec2(-0.7020127f , -0.0776734f),
                            vec2(-0.7760845f , -0.1566844f),
                            vec2(-0.5444778f , -0.6516482f),
                            vec2(-0.5331346f , 0.4946506f),
                            vec2(-0.3288236f , 0.9408244f),
                            vec2(0.5819826f , 0.8101937f),
                            vec2(-0.4894184f , -0.8290837f),
                            vec2(-0.5183194f , 0.8454953f),
                            vec2(-0.7665774f , -0.5223897f),
                            vec2(-0.6703191f , -0.6217513f),
                            vec2(-0.8902924f , -0.2446688f),
                            vec2(-0.8574848f , -0.09174173f),
                            vec2(-0.3544409f , -0.9239591f),
                            vec2(-0.969833f , -0.1172272f),
                            vec2(-0.8968207f , -0.4079512f),
                            vec2(-0.5891477f , 0.7724466f),
                            vec2(-0.2146262f , 0.5286855f),
                            vec2(-0.3762444f , -0.3014335f),
                            vec2(-0.9466863f , -0.008970681f),
                            vec2(-0.596356f , -0.7976127f),
                            vec2(-0.8877738f , 0.4569088f)
);
#endif

#if BLUR_QUALITY == 3
const vec2 dofOffsets[75] = vec2[75] (
                            vec2(1.2013739205212052e-17, 0.19619925048718512),
                            vec2(-0.18659657566806245, 0.0606289026841674),
                            vec2(-0.11532302594720426, -0.15872852792775993),
                            vec2(0.11532302594720419, -0.15872852792775996),
                            vec2(0.18659657566806245, 0.06062890268416732),
                            vec2(1.2013739205212052e-16, 0.39239850097437023),
                            vec2(-0.20707213112607778, 0.28501033751536975),
                            vec2(-0.37319315133612485, 0.1212578053683349),
                            vec2(-0.335049746284869, -0.10886426178579184),
                            vec2(-0.23064605189440857, -0.31745705585551975),
                            vec2(-1.5100170947721626e-16, -0.3522921514591555),
                            vec2(0.23064605189440832, -0.3174570558555199),
                            vec2(0.33504974628486894, -0.10886426178579214),
                            vec2(0.373193151336125, 0.12125780536833457),
                            vec2(0.2070721311260775, 0.2850103375153699),
                            vec2(1.3699306000050677e-15, 0.5885977514615552),
                            vec2(-0.2200527325980892, 0.49424652961341936),
                            vec2(-0.392706134119755, 0.3535941913819969),
                            vec2(-0.559789727004187, 0.18188670805250237),
                            vec2(-0.5380564166765633, -0.05655200820458034),
                            vec2(-0.4576409290762559, -0.26421911359436606),
                            vec2(-0.3459690778416121, -0.47618558378328013),
                            vec2(-0.1124844207730029, -0.5291975928159129),
                            vec2(0.10986848530754813, -0.5168905840606852),
                            vec2(0.3459690778416134, -0.47618558378327963),
                            vec2(0.46853722143400295, -0.27051009092028094),
                            vec2(0.5255433872887891, -0.055236835819922114),
                            vec2(0.5597897270041878, 0.18188670805250068),
                            vec2(0.4020563486136526, 0.36201316232735486),
                            vec2(0.2149351905996731, 0.48275234209297574),
                            vec2(-7.693650832814302e-16, 0.7847970019487406),
                            vec2(-0.23207427778891343, 0.7142511841527773),
                            vec2(-0.4141442622521563, 0.570020675030739),
                            vec2(-0.5723460027070446, 0.41583371170054),
                            vec2(-0.74638630267225, 0.24251561073666877),
                            vec2(-0.7510081387540958, 6.438037992811703e-16),
                            vec2(-0.6700994925697387, -0.21772852357158215),
                            vec2(-0.5723460027070453, -0.4158337117005391),
                            vec2(-0.4612921037888165, -0.6349141117110403),
                            vec2(-0.23207427778891496, -0.714251184152778),
                            vec2(6.044429619492155e-16, -0.704584302918311),
                            vec2(0.21861671970895125, -0.6728330791994982),
                            vec2(0.461292103788815, -0.6349141117110408),
                            vec2(0.6075783471659608, -0.4414315083112768),
                            vec2(0.6700994925697374, -0.21772852357158579),
                            vec2(0.7074585659961863, -6.931094947012848e-16),
                            vec2(0.7463863026722501, 0.24251561073666728),
                            vec2(0.607578347165962, 0.4414315083112759),
                            vec2(0.4141442622521572, 0.5700206750307383),
                            vec2(0.21861671970895255, 0.6728330791994979),
                            vec2(2.7637672348835945e-15, 0.9809962524359253),
                            vec2(-0.24005390909728344, 0.9349482472546294),
                            vec2(-0.42698507399497065, 0.7766829662866489),
                            vec2(-0.6028065305066238, 0.6419237556309969),
                            vec2(-0.7534600316585568, 0.4781602760187428),
                            vec2(-0.9329828783403167, 0.30314451342083026),
                            vec2(-0.9633693604274449, 0.060610062753644486),
                            vec2(-0.8706150403912548, -0.16607870115956908),
                            vec2(-0.7967832330042617, -0.3749377293206346),
                            vec2(-0.6875894007058875, -0.5688234215520268),
                            vec2(-0.5766151297360119, -0.7936426396388118),
                            vec2(-0.35534109936711206, -0.8974891684126064),
                            vec2(-0.11108461208367594, -0.8793252484106968),
                            vec2(0.11036741084397693, -0.8736480160158516),
                            vec2(0.32850641171815914, -0.8297124841348957),
                            vec2(0.5766151297360437, -0.7936426396387941),
                            vec2(0.7437564834188177, -0.6152888733675005),
                            vec2(0.8019609744964459, -0.37737418952417123),
                            vec2(0.8649940441561597, -0.16500643878106272),
                            vec2(0.8906175286699771, 0.05603290546656666),
                            vec2(0.932982878340313, 0.3031445134208707),
                            vec2(0.8150078854730223, 0.5172197317718664),
                            vec2(0.6067237519734553, 0.6460951728078184),
                            vec2(0.4242283085107431, 0.7716684284865817),
                            vec2(0.22192549197630554, 0.8643427242016442)
);
#endif

#if BLUR_QUALITY == 2
const vec2 dofOffsets[50] = vec2[50] (
                            vec2(1.5017174006515064e-17, 0.24524906310898137),
                            vec2(-0.2332457195850781, 0.07578612835520925),
                            vec2(-0.1441537824340053, -0.1984106599096999),
                            vec2(0.14415378243400523, -0.19841065990969994),
                            vec2(0.23324571958507806, 0.07578612835520915),
                            vec2(1.5017174006515063e-16, 0.49049812621796274),
                            vec2(-0.25884016390759723, 0.35626292189421216),
                            vec2(-0.4664914391701561, 0.15157225671041863),
                            vec2(-0.41881218285608623, -0.13608032723223978),
                            vec2(-0.2883075648680107, -0.39682131981939966),
                            vec2(-1.887521368465203e-16, -0.4403651893239443),
                            vec2(0.28830756486801035, -0.3968213198193999),
                            vec2(0.4188121828560862, -0.13608032723224017),
                            vec2(0.46649143917015623, 0.15157225671041819),
                            vec2(0.25884016390759684, 0.35626292189421244),
                            vec2(1.7124132500063345e-15, 0.7357471893269439),
                            vec2(-0.27506591574761147, 0.6178081620167741),
                            vec2(-0.4908826676496936, 0.4419927392274961),
                            vec2(-0.6997371587552336, 0.22735838506562794),
                            vec2(-0.672570520845704, -0.07069001025572542),
                            vec2(-0.5720511613453199, -0.33027389199295754),
                            vec2(-0.4324613473020151, -0.5952319797291),
                            vec2(-0.1406055259662536, -0.661496991019891),
                            vec2(0.13733560663443514, -0.6461132300758565),
                            vec2(0.43246134730201663, -0.5952319797290995),
                            vec2(0.5856715267925036, -0.33813761365035117),
                            vec2(0.6569292341109864, -0.06904604477490263),
                            vec2(0.6997371587552346, 0.22735838506562583),
                            vec2(0.5025704357670656, 0.45251645290919346),
                            vec2(0.26866898824959135, 0.6034404276162195),
                            vec2(-9.617063541017877e-16, 0.9809962524359257),
                            vec2(-0.29009284723614176, 0.8928139801909716),
                            vec2(-0.5176803278151952, 0.7125258437884238),
                            vec2(-0.7154325033838056, 0.5197921396256749),
                            vec2(-0.9329828783403125, 0.303144513420836),
                            vec2(-0.9387601734426196, 8.047547491014627e-16),
                            vec2(-0.8376243657121732, -0.2721606544644777),
                            vec2(-0.7154325033838066, -0.5197921396256738),
                            vec2(-0.5766151297360206, -0.7936426396388002),
                            vec2(-0.29009284723614365, -0.8928139801909724),
                            vec2(7.555537024365194e-16, -0.8807303786478886),
                            vec2(0.27327089963618906, -0.8410413489993727),
                            vec2(0.5766151297360188, -0.793642639638801),
                            vec2(0.7594729339574509, -0.5517893853890959),
                            vec2(0.8376243657121717, -0.27216065446448223),
                            vec2(0.8843232074952327, -8.663868683766059e-16),
                            vec2(0.9329828783403126, 0.3031445134208341),
                            vec2(0.7594729339574525, 0.5517893853890949),
                            vec2(0.5176803278151966, 0.7125258437884228),
                            vec2(0.27327089963619067, 0.8410413489993722)
);
#endif

#if BLUR_QUALITY == 1

const vec2 dofOffsets[30] = vec2[30] (
                            vec2(2.0022898675353416e-17,0.32699875081197516),
                            vec2(-0.3109942927801041,0.10104817114027898),
                            vec2(-0.19220504324534038,-0.2645475465462665),
                            vec2(0.1922050432453403,-0.26454754654626655),
                            vec2(0.31099429278010404,0.10104817114027885),
                            vec2(2.002289867535342e-16,0.6539975016239503),
                            vec2(-0.3451202185434629,0.47501722919228284),
                            vec2(-0.6219885855602081,0.20209634228055814),
                            vec2(-0.558416243808115,-0.18144043630965306),
                            vec2(-0.3844100864906809,-0.5290950930925328),
                            vec2(-2.516695157953604e-16,-0.587153585765259),
                            vec2(0.3844100864906805,-0.5290950930925331),
                            vec2(0.5584162438081148,-0.18144043630965356),
                            vec2(0.6219885855602082,0.2020963422805576),
                            vec2(0.3451202185434625,0.47501722919228323),
                            vec2(2.2832176666751127e-15,0.9809962524359253),
                            vec2(-0.3667545543301486,0.8237442160223655),
                            vec2(-0.6545102235329249,0.5893236523033282),
                            vec2(-0.9329828783403116,0.30314451342083726),
                            vec2(-0.8967606944609388,-0.0942533470076339),
                            vec2(-0.7627348817937598,-0.44036518932394336),
                            vec2(-0.5766151297360201,-0.7936426396388001),
                            vec2(-0.18747403462167145,-0.8819959880265213),
                            vec2(0.18311414217924682,-0.8614843067678086),
                            vec2(0.5766151297360221,-0.7936426396387992),
                            vec2(0.7808953690566715,-0.45085015153380154),
                            vec2(0.8759056454813151,-0.09206139303320351),
                            vec2(0.9329828783403129,0.3031445134208344),
                            vec2(0.6700939143560876,0.6033552705455913),
                            vec2(0.35822531766612176,0.804587236821626)
);
#endif